package estore.ui.webservice;

import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;

import org.dom4j.Attribute;
import org.dom4j.Node;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import javax.xml.soap.*;

// Element jenvelope   = SpmlDoc.getRootElement();
// JDOMSource source = new JDOMSource(jenvelope); /* I tried also JDOMSource(SpmlDoc) */
// sm.getSOAPPart().setContent(source);

public class XMLExample {

	public static void main(String[] args) {
			Document doc_out= CreateDocument();
			System.out.println(doc_out.asXML());
			String doc_str = doc_out.asXML();
			
	        SAXReader reader = new SAXReader();
	        
	        Document document = null;
	        try {
	        	document = reader.read(new StringReader(doc_str));
	        } catch (DocumentException e) {
	        	System.out.println(e);
	        }

	        // Some XPath examples, what nodes will be selected?
			QueryAllNodes(document, "//root/author" );
			QueryAllNodes(document, "/author" );
			QueryAllNodes(document, "//author" );
			QueryAllNodes(document, "//author|//root" );
			
			QueryAllNodes(document, "/root/author/address" );
			QueryAllNodes(document, "/root/author/address/*" );
			QueryAllNodes(document, "/root/author/*/*" );
			QueryAllNodes(document, "/root/author/address/*" );
			
			QueryAllNodes(document, "/root/author/address/*[1]" );
			QueryAllNodes(document, "/root/author/address[@type]" );
			QueryAllNodes(document, "/root/author/address/@type" ); // type attributes
			QueryAllNodes(document, "/root/author/address[@type='mailing']" );
			QueryAllNodes(document, "/root/author/address[country]" );
			
			QueryAllNodes(document, "/root/author/address[country='UK']" );
			QueryAllNodes(document, "/root/author[@first_name='James']/address[country='UK']" );
			QueryAllNodes(document, "/root/author[@first_name='Bob']/address[country='UK']" );
			QueryAllNodes(document, "/root/author/address[country='UK']/parent::*" );

			QueryAllNodes(document, "/root/author/address[country='UK']/ancestor::*" );
			QueryAllNodes(document, "/root/author/address[country='UK']/descendant::*" );
			QueryAllNodes(document, "/root/author/address[country='UK']/following::*" );
			QueryAllNodes(document, "/root/author/address[country='UK']/preceding::*" );
	}
	
    public static Document CreateDocument() {
        Document document = DocumentHelper.createDocument();
        Element root = document.addElement( "root" );

        Element author1 = root.addElement( "author" )
            .addAttribute( "first_name", "James" )
            .addAttribute( "location", "UK" )
            .addText( "James Strachan" );
        
        Element addr1 = author1.addElement( "address" );
        addr1.addElement("city").addText("London");
        addr1.addElement("country").addText("UK");
        addr1.addAttribute("type", "mailing");

        Element author2 = root.addElement( "author" )
            .addAttribute( "first_name", "Bob" )
            .addAttribute( "location", "US" )
            .addText( "Bob McWhirter" );

        Element addr2 = author2.addElement( "address" );
        addr2.addElement("city").addText("New York");
        addr2.addElement("country").addText("US");
        addr2.addAttribute("type", "temporary");

        return document;
    }

    public static void QueryAllNodes(Document doc, String xpath) {
    	System.out.println("XPath All Nodes Query: '" + xpath + "': ");
    	List l = doc.selectNodes(xpath);
    	Iterator i = l.iterator();
    	int index = 1;
    	while (i.hasNext()) {
    		Node n = (Node)i.next();
    		if (n instanceof Element) {
	    		Element e = (Element)n;
	    		System.out.print("[" + index++ + "] Element: '" + e.getQualifiedName() + "'");
	    		System.out.println(", Text: '" + e.getText() + "'");
	    		for (Iterator j = e.attributeIterator(); j.hasNext(); ) {
	    			Attribute a = (Attribute)j.next();
		    		System.out.println("    - Attribute: '" + 
		    				a.getQualifiedName() + "'='" + 
		    				a.getValue() + "'");
	    		}    
	    		for (Iterator j = e.elementIterator(); j.hasNext(); ) {
	    			Element c = (Element)j.next();
		    		System.out.println("    - Child Element: '" + 
		    				c.getQualifiedName() +  
		    				"', Text: '" + c.getText() + "' ...");
	    		}    
    		} else if (n instanceof Attribute) {
    			Attribute a = (Attribute)n;
	    		System.out.println("[" + index++ + "] Attribute: '" + 
	    				((Attribute)a).getQualifiedName() + "'='" + 
	    				((Attribute)a).getValue() + "'");
    		}
    	}
    	System.out.println();
    }
    
    public static void TestSAAJ() {
    	SOAPMessage m = null;
    	// m.getSOAPPart().getEnvelope().getBody().addDocument(DOM Document); 
    }
    
    // Namespaces for XPATH
    
    //Map uris = new HashMap();
    //uris.put( "SOAP-ENV", "http://schemas.xmlsoap.org/soap/envelope/" );
    //uris.put( "m", "urn:xmethodsBabelFish" );        
    //XPath xpath = document.createXPath( "/SOAP-ENV:Envelope/SOAP-ENV:Body/m:BabelFish" );
    //xpath.setNamespaceURIs( uris );        
    //Node element = xpath.selectSingleNode( document );
    //In addition DocumentFactory has a setXPathNamespaceURIs(Map) method so that common namespace URIs can be associated with a DocumentFactory so namespace prefixes can be used across many XPath expressions in an easy way. e.g. 

    //     register prefixes with my factory
    //Map uris = new HashMap();
    //uris.put( "SOAP-ENV", "http://schemas.xmlsoap.org/soap/envelope/" );
    //uris.put( "m", "urn:xmethodsBabelFish" );        

    //DocumentFactory factory = new DocumentFactory();
    //factory.setXPathNamespaceURIs( uris );

    //     now parse a document using my factory
    //SAXReader reader = new SAXReader();
    //reader.setDocumentFactory( factory );
    //Document doc = reader.read( "soap.xml" );

    //     now lets use the prefixes
    //Node element = doc.selectSingleNode( "/SOAP-ENV:Envelope/SOAP-ENV:Body/m:BabelFish" );
}
